/* Version: MPL 1.1/GPL 2.0/LGPL 2.1
 * 
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 * 
 * The Original Code is Timestamp.
 * 
 * The Initial Developer of the Original Code is Jeroen Peters. 
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *   Jeroen Peters <jpeters@coldmail.nl>
 * 
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 * 
 * ***** END LICENSE BLOCK ***** */

var prefString  = "timestamp.mode_index";
var prefDefault = 0;

function hasExtensionManager() {
  var result = false;
  try {
    var gExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"]
                                      .getService(Components.interfaces.nsIExtensionManager);
    result = true;
  }
  catch (E) {
    result = false;
  }

  return result;
}

function init() {
  // initialize the default values
  if (parent.tsPrefWindow) {
    // Thunderbird
    var elem = document.getElementById("timestampMode");
    if (elem) {
      var mode = getTimestampModePref(); 
      elem.selectedIndex = mode;
    }
  } else {
    // Mozilla
    parent.initPanel('chrome://timestamp/content/pref-timestamp.xul');
    var mode = getTimestampModePref(); 
    
    // Show uninstall button in the panel
    elem = document.getElementById("uninstallBox");
    if (elem)
      elem.hidden = false;
  }
  
  updatePreview(mode);

  // Remove uninstall button in Thunderbird 0.7 and up
  var newExtensionManger = hasExtensionManager();
  if (newExtensionManger) {
    var button = parent.document.documentElement.getButton("extra2");
    button.hidden = true;
  }
}


function getTimestampModePref() {
  //var result = nsPreferences.copyUnicharPref(prefString, prefDefault);
  var result = nsPreferences.getIntPref(prefString, prefDefault);

  return result;
}


function savePrefs() {
  var elem = document.getElementById("timestampMode");
  if (elem) {
    var value = parseInt(elem.value, 10);
    
    //nsPreferences.setUnicharPref(prefString, elem.value);
    nsPreferences.setIntPref(prefString, value);
  }
}


function updatePreview(mode) {
  var elem = document.getElementById("timestampPreview");
  if (elem)
    elem.value = timestamp_getCurrentDateTime(mode);
}


function doUninstall()
{
  var bundleSettings = document.getElementById("bundle_tssettings");
  
  if( window.confirm(bundleSettings.getString("confirmUninstall")) )
  {
    var unreg = new exUnregisterer(
                      'chrome://timestamp/content/contents.rdf',
		      'jar:%chromeFolder%timestamp.jar!/locale/en-US/timestamp/contents.rdf'
                    );
    unreg.unregister();
    if( window.confirm(bundleSettings.getString("confirmDeletePrefs")) ) {
      unreg.removePrefs('timestamp');
    }
    window.close();
  }
}
