/* Version: MPL 1.1/GPL 2.0/LGPL 2.1
 * 
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 * 
 * The Original Code is Timestamp.
 * 
 * The Initial Developer of the Original Code is Jeroen Peters. 
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *   Jeroen Peters <jpeters@coldmail.nl>
 * 
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 * 
 * ***** END LICENSE BLOCK ***** */

var gEditor;             // the editor we're using

function timestamp_insertTimestamp() {
  var mode = getTimestampModePref();
  var timestampStr = timestamp_getCurrentDateTime(mode);

  timestamp_insertIntoEditor(timestampStr);
}

function timestamp_getCurrentDateTime(mode) {
  var timestamp = new Date();
  var result = "<error>";

  switch (mode) {
    case 0:
    case "0":
    //case "localedatetime":
      result = timestamp.toLocaleString();
      break;
    case 1:
    case "1":
    //case "datetime":
      result = timestamp.toLocaleDateString();
      result += ", " + timestamp.toLocaleTimeString();
      break;
    case 2:
    case "2":
    //case "date":
      result = timestamp.toLocaleDateString();
      break;
    case 3:
    case "3":
    //case "time":
      result = timestamp.toLocaleTimeString();
      break;
  }
  
  return result;
}

function timestamp_insertIntoEditor(timestampStr) {
  // If we don't get the editor, then we won't allow timestamp inserting.
  gEditor = GetCurrentEditor();
  
  if (gEditor)
    gEditor.insertText(timestampStr);
}
